//control.h

void GameLoop ()
{
  static S2 i = 0,
    Ende = 0,
    j = 0,
    mx_old,
    my_old;

  gii_event_mask mask;
  gii_event event;

  while (!Ende)
  {
    struct timeval tval;
    tval.tv_sec = 0;
    tval.tv_usec = 0;
    while ((mask = ggiEventPoll (vis, emAll, &tval)) != 0)
    {
      mx_old = mx;
      my_old = my;
      ggiEventRead (vis, &event, emAll);
      switch (event.any.type)
      {
      case evPtrAbsolute:
        mx = event.pmove.x;
        my = event.pmove.y;
        break;
      case evPtrRelative:
        mx += event.pmove.x;
        my += event.pmove.y;
        break;

      case evPtrButtonPress:
        switch (event.pbutton.button)
        {
        case GII_PBUTTON_PRIMARY:
          if (!Rahmen)
          {
            Rahmen = 1;
            RahmenX = mx;
            RahmenY = my;
          }
          break;
        case GII_PBUTTON_SECONDARY:
          if (!RightScroll)
          {
            RightScroll = 1;
            RightScrollX = mx;
            RightScrollY = my;
          }
          break;
        };
        break;
      case evPtrButtonRelease:
        switch (event.pbutton.button)
        {
        case GII_PBUTTON_PRIMARY:
          if (Rahmen == 2)
          {
            for (i = 0; i < LMAX; i++)
            {
              Leute[i].aktive = 0;
              if ((!Leute[i].feind) &&
                  (Leute[i].x >= min (mx, RahmenX)) &&
                  (Leute[i].x <= max (mx, RahmenX)) &&
                  (Leute[i].y >= min (my, RahmenY)) &&
                  (Leute[i].y <= max (my, RahmenY)))
              {
                Leute[i].aktive = 1;
                MouseSet (2);
              }
            }
            MouseDelete = 1;
          }
          else
          {
            int found = 0;
            for (i = 0; i<LMAX && !found ;)
            {
              // Zeigt der Mauszeiger auf eine Einheit
              if (maus_innen (Leute[i].x, Leute[i].y, Leute[i].x + Leute[i].shapeX, Leute[i].y + Leute[i].shapeY) && (Leute[i].free))
                found = 1;
              else
                i++;
            }
            if (found)
            {
              // Feindliche Einheit wird angegriffen
              if (Leute[i].feind)
              {
                for (j = 0; j < LMAX; j++)
                {
                  if (Leute[j].free && Leute[j].aktive && !Leute[j].feind)
                  {
                    // Alle Aktivierten greifen die Einheit an
                    Leute[j].attack = 1;
                    Leute[j].who = i;
                  }
                }
              }
              // Eigene Einheit wird ausgewhlt //
              else
              {
                for (j = 0; j < LMAX; j++)
                  Leute[j].aktive = 0;
                Leute[i].aktive = 1;
                MouseDelete = 1;
              }
            }
            else
            { // Mauszeiger steht auf der Landkarte
              printf ("Klick1\n");
              // Wenn die Stelle begehbar ist //
              if (Karte[(my + ScrollY) / 20][(mx + ScrollX) / 20] <= Hindernis)
              {
                printf ("Klick2\n");
                for (j = 0; j < LMAX; j++)
                {
                  if (Leute[j].free && Leute[j].aktive && !Leute[j].feind)
                  {
                    // Zielkoordinaten angeben //
                    Leute[j].attack = 0;
                    Leute[j].dx = mx + ScrollX;
                    Leute[j].dy = my + ScrollY;
                    Leute[j].dcount = Leute[j].d1count = 0;
                    WegSuchen (j);
                  }
                }
              }
              MouseDelete = 1;
            }
          }
          Rahmen = 0;

          break;
        case GII_PBUTTON_SECONDARY:
          if (RightScrolled != 2)
          {
            for (i = 0; i < LMAX; i++)
              if (Leute[i].aktive)
                Leute[i].aktive = 0;
          }
          //MouseSet (0);
          RightScroll = RightScrolled = 0;
          MouseDelete = 1;
          break;
        };
        break;
      case evKeyPress:
        i = event.key.sym;
        if (i == 27)
          Ende = 1;

        if (i == 48)
          MInsert (ScrollX + mx, ScrollY + my, ScrollX + mx, ScrollY + my, 8);
        if (48<i && i<53)
          MInsert (ScrollX + mx, ScrollY + my, ScrollX + mx, ScrollY + my, i - 49);
        if (i == 57)
          MInsert (ScrollX + mx, ScrollY + my, ScrollX + mx, ScrollY + my, 9);
        if (96<i && i<101)
          FInsert (ScrollX + mx, ScrollY + my, ScrollX + mx, ScrollY + my, i - 93);

        if (i == '+')
          GameSpeed >>= 1;
        if (i == '-')
          GameSpeed <<= 1;
        GameSpeed=minmax(1,GameSpeed,8);
        if (i == '^')
          edit = !edit;
        if (i == 9)
          for (j = 0; j < LMAX; j++)
            if ((Leute[j].free) && (Leute[j].x > Mlinks) && (Leute[j].x < Mrechts) && (Leute[j].y > Moben) && (Leute[j].y < Munten) && (!Leute[j].feind))
            {
              Leute[j].aktive = 1;
              MouseSet (2);
            }
        if (i == 'x')
          for (j = 0; j < LMAX; j++)
            if (Leute[j].aktive)
            {
              Leute[j].dx += rand () % 20;
              Leute[j].dy -= rand () % 20;
            }
      case evKeyRepeat:
      case evKeyRelease:
        break;

      case evExpose:
        //redraw_screen(event.expose.x, event.expose.y,event.expose.w, event.expose.h); // redraw part of screen...
        break;
      default:
        printf ("Ein unerwartetes Ereignis ist aufgetreten!\n");
      }
      mx = minmax (0, mx, WIDTH - 1);
      my = minmax (0, my, HEIGHT - 1);
      if (mx_old != mx || my_old != my)	//Mouse moved

      {
        if (Rahmen == 1)
          Rahmen = 2;

        if (RightScroll)
        {
          if ((mx < RightScrollX) && (ScrollX > 0))
          {
            ScrollLeft ();
            NachScroll = RightScrollX - mx;
            ScrollDir = 1;
          }
          if ((mx > RightScrollX) && (ScrollX < (FeldX * 20) - WIDTH))
          {
            ScrollRight ();
            NachScroll = mx - RightScrollX;
            ScrollDir = 2;
          }
          if ((my < RightScrollY) && (ScrollY > 0))
          {
            ScrollUp ();
            NachScroll = RightScrollY - my;
            ScrollDir = 3;
          }
          if ((my > RightScrollY) && (ScrollY < (FeldY * 20) - HEIGHT - 20))
          {
            ScrollDown ();
            NachScroll = my - RightScrollY;
            ScrollDir = 4;
          }
          RightScrollX = mx;
          RightScrollY = my;
        }

      }
    };

    if (MouseImage != 2)
      MouseSet (0);

    for (i = 0; i < LMAX; i++)
    {
      if (maus_innen (Leute[i].x, Leute[i].y, Leute[i].x + Leute[i].shapeX, Leute[i].y + Leute[i].shapeY) && Leute[i].free)
        MouseSet (Leute[i].feind ? 4 : 3);
    }

    if (Karte[(my + ScrollY) / 20][(mx + ScrollX) / 20] > Hindernis)
      MouseSet (1);

    NachScrollen ();            // Sanftes AusScrollen

    DoScroll ();                // Scrollt, wenn Maus am Bildschrirmrand ist

    Landschaft ();              // Und wieder ein neuer Frame

    if (edit)
      PutSprite ((mx / 20) * 20, (my / 20) * 20, EditSelect);

    for (i = 0; i < LMAX; i++)
      if (Leute[i].free)
      {
        Leute[i].warten++;
        if (Leute[i].warten >= (Data[Leute[i].type].speed + GameSpeed))
        {
          MVerhalten (i);
          Leute[i].warten = 0;
        }
        if (Leute[i].aktive)
          MouseImage = 2;
        Leute[i].x = Leute[i].ax - ScrollX;
        Leute[i].y = Leute[i].ay - ScrollY;
        if ((Leute[i].x < Mrechts) && (Leute[i].x + 20 > Mlinks) && (Leute[i].y < Munten) && (Leute[i].y + 20 > Moben))
        {
          if ((Leute[i].aktive) && (!Leute[i].feind))
            MSetAkt (i);
          else
            MSet (i);
        }
      }

    for (i = 0; i <= EMAX; i++)
    {
      if (Explose[i].free == 1)
        ExploseCompute (i);
      if (Laser[i].free == 1)
        LaserCompute (i);
      if (Rauch[i].free == 1)
        RauchCompute (i);
      if (Rocket[i].free == 1)
        RocketCompute (i);
    }

    // Zeichnet den Rahmen falls ntig
    if (Rahmen == 2)
      draw_box (min (mx, RahmenX), min (my, RahmenY), max (mx, RahmenX), max (my, RahmenY), GELB_HELL);

    InterFace ();               // Zeichnet das BenutzerInterface

    if (edit)
    {
      ShowSpriteSelect ();
      ShowEditInterface ();
    }

    MousePlace ();

#if 0
    for (m_show_image = 0; m_show_image < 15; m_show_image++)
    {
      mx = m_show_image * 30 + 10;
      my = 20;
      MousePlace ();
    }
#endif

    if (GameDel >= GameSpeed)
    {
      GameDel = 0;
      if (m_show_image < m_image_end)
        m_show_image++;
      else
        m_show_image = m_image_start;
      AniKarte ();
    }
    else
      GameDel++;

    Iwrite (1, 1, LaserAnz, 254);
    Cpy2Screen ();
  }
}
